<?php
if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class Inventory_category_master extends REF_Controller {
    public function __construct() {
        parent::__construct();
        $this->load->library('upload');
        $this->load->model('inventory_category_master_model', '', TRUE);
        $this->uri_key_index = 0;
    }
    
    public function index() {
        $data = array();
        $data['results'] = $this->inventory_category_master_model->list_all();
        if (!empty($this->session->flashdata('success'))) 
            $data['success'] = $this->session->flashdata('success');
        else 
            $data['error'] = $this->session->flashdata('error');
        
        $actions = $this->actions();
        $data['add_btn']    = 'New Inventory Category';
        $data['view_link']  = $actions['view'] . '/';
        $data['add_link']   = $actions['add'];
        $data['edit_link']  = $actions['edit'] . '/';
        $data['delete_link']= $actions['delete'] . '/';
        
        $service_menu_id = get_inventory_controller_id($actions['controller']);
        $data['service_menu_id'] = array('service_menu_id' => $service_menu_id, 'menu_type' => '3');
        $this->render($data, 'inventory_category/list');
    }
    
    private function get_category_url_key($name, $id = '') {
        $url_key = get_url_key($name);
        if ($this->inventory_category_master_model->category_url_key_exists($url_key, $id)) {
            $this->uri_key_index ++;
            return $this->get_category_url_key($name . '_' . $this->uri_key_index, $id);
        }
        
        return $url_key;
    }
    
    public function add() {
        $data 					= array();
        $actions			 	= $this->actions();
        $data['form_action'] 	= $actions['insert'];
        $data['code'] 			= generate_rec_no( TBL_INVENTORY_CATEGORY, array('is_statue_cat' => 0) );  
        
        $this->render($data, 'inventory_category/add');
    }
    
    public function insert() {
        $insert = array(
            'code' => $this->input->post('code'),
            'name' => $this->input->post('category_name'),
            'cat_slug'  => get_var_name($this->input->post('category_name')),
            'description' => $this->input->post('desc'),
            'url_key' => $this->get_category_url_key($this->input->post('category_name')),
            'status' => $this->input->post('status'),
            'created_by' => $this->user_data['user_id'],
            'created_on' => date('Y-m-d H:i:s')
        );
        
        $insert_id = $this->inventory_category_master_model->insert($insert);  
        if ($insert_id > 0)
            $this->session->set_flashdata('success', 'Category added successfully');    
        
        else
            $this->session->set_flashdata('error', 'Category not added!');
        redirect('inventory_category_master', 'refresh');
    }
    
    public function edit($id = '') {
        if (empty($id)) {
            show_400_error();
        }
        
        $data 					= array();
        $data['category'] 		= $this->inventory_category_master_model->get_by_id($id);
        $actions 				= $this->actions();
        $data['form_action'] 	= $actions['update'] . '/' . $id;
        $this->render($data, 'inventory_category/edit');
    }
    
    public function update($id = '') {
        if (empty($id)) {
            show_400_error();
        }
        
        $update = array(
            'code' => $this->input->post('code'),
            'name' => $this->input->post('category_name'),
            'cat_slug'  => get_var_name($this->input->post('category_name')),
            'description' => $this->input->post('desc'),
            'url_key' => $this->get_category_url_key($this->input->post('category_name')),
            #'status' => $this->input->post('status'),
            'updated_by' => $this->user_data['user_id'],
            'updated_on' => date('Y-m-d H:i:s')
        );
        
        
        if ( $this->inventory_category_master_model->update($update, $id) > 0)
            $this->session->set_flashdata('success', 'Category updated successfully');  
       
        else
            $this->session->set_flashdata('error', 'Category not updated!');    
        
        redirect('inventory_category_master','refresh');
    }
    
    public function view($id = '') {
        if (empty($id)) {
            show_400_error();
        }
        
        $data = array();
        $data['category'] = $this->inventory_category_master_model->get_by_id($id);
        $this->render($data, 'inventory_category/view');
    }
    
    public function delete($id = '') {
        if (empty($id)) {
            show_400_error();
        }
        
        $update = array ( 
            'status' => 2,
            'updated_by' => $this->user_data['user_id'],
            'updated_on' => date('Y-m-d H:i:s')
        );
        
        if ($this->inventory_category_master_model->update($update,$id) > 0)
            $this->session->set_flashdata('success', 'Category deleted successfully');
            
        else 
            $this->session->set_flashdata('error', 'Category not deleted!');
        
        redirect( 'inventory_category_master', 'refresh');
    }
    
    public function category_name_exists() {
        $data =  $this->inventory_category_master_model->category_name_exists($_POST['category_name'], $_POST['category_id']);
        echo json_encode($data);
        exit(0);
    }
}
?>